import { isVue3 as g, h as I, Vue2 as ze, computed as $, unref as ke, inject as Be, provide as Me, ref as C, onMounted as Oe, onUpdated as He, defineComponent as G, getCurrentInstance as Ke, watch as N, onBeforeUnmount as Le } from "vue-demi";
import j from "vue";
import { offset as qe, shift as Ye, flip as Ge, autoPlacement as Je, arrow as Qe } from "@floating-ui/core";
import { useManualEffect as Xe } from "@visoning/vue-floating-core";
import { FloatingCreatorProps as Ze, FloatingCreator as et } from "@visoning/vue-floating-core/components";
import { useInteractionsContext as tt, useClick as rt, useFocus as nt, useHover as ot } from "@visoning/vue-floating-interactions";
function W(e, t) {
  const r = {};
  for (let n = 0; n < t.length; n++) {
    const o = t[n];
    o in e && (r[o] = e[o]);
  }
  return r;
}
var at = Object.defineProperty, lt = Object.defineProperties, st = Object.getOwnPropertyDescriptors, ne = Object.getOwnPropertySymbols, it = Object.prototype.hasOwnProperty, ct = Object.prototype.propertyIsEnumerable, oe = (e, t, r) => t in e ? at(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, pt = (e, t) => {
  for (var r in t || (t = {}))
    it.call(t, r) && oe(e, r, t[r]);
  if (ne)
    for (var r of ne(t))
      ct.call(t, r) && oe(e, r, t[r]);
  return e;
}, ut = (e, t) => lt(e, st(t));
const T = ut(pt({}, W(Ze, [
  "placement",
  "strategy",
  "middleware",
  "autoUpdate"
])), {
  open: {
    type: Boolean,
    default: void 0
  },
  defaultOpen: Boolean,
  disabled: Boolean,
  virtualElement: Object,
  appendTo: {
    default: "body"
  },
  interactions: {
    type: Array,
    default: () => ["hover"]
  },
  delay: [Number, Object],
  clickDelay: [Number, Object],
  hoverDelay: [Number, Object],
  focusDelay: [Number, Object],
  keepOpenWhenPopupHover: {
    type: Boolean,
    default: !0
  },
  closeWhenClickOutside: {
    type: Boolean,
    default: !0
  },
  autoUpdateOnClosed: Boolean,
  offset: [Number, Object, Function],
  shift: {
    type: [Boolean, Object],
    default: !0
  },
  flip: [Boolean, Object],
  autoPlacement: [Boolean, Object],
  gpuAcceleration: Boolean,
  destoryedOnClosed: Boolean,
  referenceProps: Object,
  popupProps: Object,
  popupWrapper: Function,
  floatingWrapper: Function,
  zIndex: Number,
  "onUpdate:open": Function,
  onOpen: Function,
  onClose: Function,
  onFloatingDataUpdate: Function
}), ft = /^on[^a-z]/, U = (e) => ft.test(e);
function J(e) {
  return U(e) && (e = e.replace(/^on-?/, ""), e = e.charAt(0).toLowerCase() + e.slice(1)), e;
}
function dt(e) {
  return Object.entries(e).reduce((t, [r, n]) => (t[J(r)] = n, t), {});
}
const E = g ? j.mergeProps : (...e) => {
  const t = {};
  for (let r = 0; r < e.length; r++) {
    const n = e[r];
    for (const o in n)
      o === "class" ? t.class !== n.class && (t.class = he([t.class, n.class])) : o === "style" ? t.style = be([t.style, n.style]) : U(o) ? Object.assign(t, Q(t, n)) : o !== "" && (t[o] = n[o]);
  }
  return t;
};
function Q(...e) {
  const t = {};
  for (let r = 0; r < e.length; r++) {
    const n = e[r];
    for (let o in n) {
      const l = t[o], d = n[o];
      d && l !== d && !(X(l) && l.includes(d)) && (t[o] = l ? [].concat(l, d).flat() : d);
    }
  }
  return t;
}
const X = Array.isArray, L = (e) => typeof e == "string", we = (e) => e !== null && typeof e == "object";
function be(e) {
  if (X(e)) {
    const t = {};
    for (let r = 0; r < e.length; r++) {
      const n = e[r], o = L(n) ? mt(n) : be(n);
      if (o)
        for (const l in o)
          t[l] = o[l];
    }
    return t;
  } else {
    if (L(e))
      return e;
    if (we(e))
      return e;
  }
}
const vt = /;(?![^(]*\))/g, yt = /:(.+)/;
function mt(e) {
  const t = {};
  return e.split(vt).forEach((r) => {
    if (r) {
      const n = r.split(yt);
      n.length > 1 && (t[n[0].trim()] = n[1].trim());
    }
  }), t;
}
function he(e) {
  let t = "";
  if (L(e))
    t = e;
  else if (X(e))
    t += e.map(he).join(" ");
  else if (we(e))
    for (const r in e)
      e[r] && (t += r + " ");
  return t.trim();
}
var _t = Object.defineProperty, Pt = Object.defineProperties, gt = Object.getOwnPropertyDescriptors, ae = Object.getOwnPropertySymbols, Ot = Object.prototype.hasOwnProperty, wt = Object.prototype.propertyIsEnumerable, le = (e, t, r) => t in e ? _t(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, bt = (e, t) => {
  for (var r in t || (t = {}))
    Ot.call(t, r) && le(e, r, t[r]);
  if (ae)
    for (var r of ae(t))
      wt.call(t, r) && le(e, r, t[r]);
  return e;
}, ht = (e, t) => Pt(e, gt(t));
function _(e, t, r) {
  r = Array.isArray(r) ? r : [r];
  let n = t.propsKey;
  if (!n && !g) {
    if (typeof e == "string") {
      const c = I(e);
      typeof c.tag == "string" && c.tag.indexOf("vue-component") !== 0 && (n = "attrs");
    }
    n || (n = "props");
  }
  const { data: o, scopedSlots: l } = t;
  if (g)
    return I(e, o, l ? ht(bt({}, l), {
      default: (...c) => {
        var R;
        return r.concat((R = l.default) == null ? void 0 : R.call(l, ...c));
      }
    }) : r);
  const d = [
    "key",
    "ref",
    "tag",
    "class",
    "style",
    "directives",
    "slots",
    "scopedSlots"
  ], p = {};
  "attrs" in o && (p.attrs = o.attrs);
  for (const c in o)
    U(c) ? p.on = Q(p.on, {
      [J(c)]: o[c]
    }) : d.includes(c) ? p[c] = o[c] : (p[n] || (p[n] = {}))[c] = o[c];
  if (l)
    for (const c in l)
      (p.scopedSlots || (p.scopedSlots = {}))[c] = l[c];
  return I(e, p, r);
}
const $t = (e) => {
  const t = {};
  if (g) {
    const n = j.createApp(e);
    let o;
    return t.mount = (l) => o = n.mount(l || document.createElement("div")), t.unmount = () => n.unmount(), Object.defineProperties(t, {
      $el: {
        configurable: !0,
        get() {
          return o == null ? void 0 : o.$el;
        }
      },
      isMounted: {
        configurable: !0,
        get() {
          return !!(o != null && o.isMounted);
        }
      }
    }), t;
  }
  const r = new ze(e);
  return t.mount = (n) => r.$mount(n), t.unmount = () => {
    r.$destroy(), r.$el.remove();
  }, Object.defineProperties(t, {
    $el: {
      configurable: !0,
      get() {
        return r.$el;
      }
    },
    isMounted: {
      configurable: !0,
      get() {
        return r._isMounted;
      }
    }
  }), t;
};
function jt(...e) {
  return $(() => {
    const t = {};
    for (let r = 0; r < e.length; r++) {
      const n = ke(e[r]);
      t.floating = E(t.floating, n.floating), t.reference = E(t.reference, n.reference);
    }
    return t;
  });
}
const xt = g ? (e) => j.getTransitionRawChildren(e, !1) : (e) => e.filter((t) => !t.isComment), Ct = g ? (e) => e.type === j.Text || e.type === "svg" || typeof e != "object" : (e) => !e.tag, Et = (e) => e && !Ct(e) ? e : _("span", {
  data: {
    class: "visoning-text-wrapper"
  }
}, [e]), Z = Symbol("ForwardReferenceInjectionKey"), se = {}, $e = () => {
  const e = Be(Z, se);
  return e === se ? void 0 : e;
}, mr = () => {
  const e = $e();
  if (!e)
    throw new Error(`injection "${String(Z)}" not found; please ensure the component is wrapped in a <Provider>`);
  return e;
}, St = (e) => {
  Me(Z, e);
}, Dt = (e) => {
  const t = e || C(null);
  return St({
    forwardReference: (r) => t.value = r
  }), t;
}, je = (e) => Boolean(e && e.nodeType === 1);
function Rt(e) {
  const t = C(null);
  let r;
  return g ? r = () => {
    const n = e == null ? void 0 : e.vnode;
    t.value = n && q([n]) || null;
  } : r = () => {
    var n;
    const o = (n = e == null ? void 0 : e.proxy) == null ? void 0 : n.$el;
    t.value = je(o) ? o : null;
  }, Oe(r), He(r), t;
}
function q(e) {
  var t, r;
  for (let n = 0; n < e.length; n++) {
    const o = e[n];
    if (!(o.type === Comment || o.type === Text)) {
      if (je(o.el))
        return o.el;
      if (o.shapeFlag & 6 && ((t = o.component) == null ? void 0 : t.subTree))
        return q([(r = o.component) == null ? void 0 : r.subTree]);
      if (Array.isArray(o.children))
        return q(o.children);
    }
  }
}
var Ft = Object.defineProperty, At = Object.defineProperties, It = Object.getOwnPropertyDescriptors, z = Object.getOwnPropertySymbols, xe = Object.prototype.hasOwnProperty, Ce = Object.prototype.propertyIsEnumerable, ie = (e, t, r) => t in e ? Ft(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, ce = (e, t) => {
  for (var r in t || (t = {}))
    xe.call(t, r) && ie(e, r, t[r]);
  if (z)
    for (var r of z(t))
      Ce.call(t, r) && ie(e, r, t[r]);
  return e;
}, Tt = (e, t) => At(e, It(t)), Wt = (e, t) => {
  var r = {};
  for (var n in e)
    xe.call(e, n) && t.indexOf(n) < 0 && (r[n] = e[n]);
  if (e != null && z)
    for (var n of z(e))
      t.indexOf(n) < 0 && Ce.call(e, n) && (r[n] = e[n]);
  return r;
};
const pe = {
  popup: "visoning-popup",
  floating: "visoning-floating"
}, Ut = G({
  name: "VisoningPopup",
  inheritAttrs: !1,
  props: T,
  setup(e, { emit: t, slots: r, expose: n }) {
    const o = C(!!e.defaultOpen), l = $(() => e.open === void 0 ? o.value : e.open), d = (a, i) => {
      o.value = a, a !== e.open && (t("update:open", a, i), t(a ? "open" : "close", i));
    }, p = Ke(), c = Rt(p), R = Dt(), s = $(() => c.value || R.value), u = $e();
    u && N(s, () => u.forwardReference(s.value));
    const O = $(() => e.virtualElement || s.value), P = C(), v = tt(O, P);
    N(v.open, (a) => {
      d(a, v.info.value);
    }), N(l, (a) => {
      v.open.value !== a && v.setOpen(a, {
        type: "component"
      });
    });
    const b = (a) => e.interactions.includes(a), x = jt(ot(v, $(() => {
      var a;
      return {
        disabled: !b("hover"),
        delay: (a = e.hoverDelay) != null ? a : e.delay,
        keepOpenWhenPopupHover: !!e.keepOpenWhenPopupHover
      };
    })), nt(v, $(() => {
      var a;
      return {
        disabled: !b("focus"),
        delay: (a = e.focusDelay) != null ? a : e.delay
      };
    })), rt(v, $(() => {
      var a;
      return {
        disabled: !b("click"),
        delay: (a = e.clickDelay) != null ? a : e.delay,
        closeWhenClickOutside: !!e.closeWhenClickOutside
      };
    })), {
      floating: e.popupProps,
      reference: e.referenceProps
    }), h = C();
    n({
      getFloatingData: () => {
        var a;
        return (a = h.value) == null ? void 0 : a.getFloatingData();
      },
      updatePosition: () => {
        var a;
        return (a = h.value) == null ? void 0 : a.updatePosition();
      }
    });
    const F = (a, i = {}) => typeof a == "object" ? a : i, B = $(() => {
      const a = [];
      return e.offset && a.push(qe(e.offset)), e.shift && a.push(Ye(F(e.shift))), e.flip && a.push(Ge(F(e.flip))), e.autoPlacement && a.push(Je(F(e.autoPlacement))), a.concat(e.middleware || []);
    }), Ie = (a) => {
      var i;
      const { value: y } = l;
      if (!y && e.destoryedOnClosed)
        return;
      let m = _("div", {
        data: E(x.value.floating, {
          class: pe.popup
        })
      }, (i = r.default) == null ? void 0 : i.call(r, a));
      if (g)
        j.withDirectives(m, [[j.vShow, y, "show"]]);
      else {
        const w = {
          name: "show",
          value: y
        };
        (m.data.directives || (m.data.directives = [])).push(w);
      }
      const { popupWrapper: f } = e;
      return f ? f(m) : m;
    }, M = C(null);
    if (!g) {
      const a = () => {
        const m = $t({
          render() {
            return M.value;
          }
        });
        m.mount();
        const { appendTo: f } = e;
        return (typeof f == "string" ? document.querySelector(f) : f).appendChild(m.$el), m.unmount;
      }, { clear: i, reset: y } = Xe(a);
      N(() => e.appendTo, (m) => {
        m ? y() : i();
      }), Oe(y), Le(i);
    }
    const Te = (a) => e.gpuAcceleration ? {
      position: a.strategy,
      top: 0,
      left: 0,
      transform: `translate3d(${a.x}px, ${a.y}px, 0px)`,
      zIndex: e.zIndex
    } : {
      position: a.strategy,
      top: `${a.y}px`,
      left: `${a.x}px`,
      zIndex: e.zIndex
    }, We = (a, i) => {
      let y = _("div", {
        data: {
          ref: P,
          class: pe.floating,
          style: Te(a)
        }
      }, [i]);
      if (e.floatingWrapper && (y = e.floatingWrapper(y)), M.value = null, !e.appendTo)
        return y;
      if (g)
        return _(j.Teleport, {
          data: {
            to: e.appendTo
          },
          scopedSlots: {
            default: () => [y]
          }
        });
      M.value = y;
    }, Ue = (a, i) => {
      var y;
      const m = r.reference && xt(r.reference(a));
      if (!m)
        return;
      let f = Et(m[0]);
      if (g)
        return f = j.cloneVNode(f, ce({}, E((y = p == null ? void 0 : p.proxy) == null ? void 0 : y.$attrs, x.value.reference))), [f, i];
      {
        const w = f.data || (f.data = {}), ee = E(Tt(ce({}, w.attrs), {
          class: w.class,
          style: w.style
        }), x.value.reference), {
          class: Ne,
          style: Ve
        } = ee, H = Wt(ee, [
          "class",
          "style"
        ]), te = {}, re = {};
        for (const D in H)
          U(D) ? te[D] = H[D] : re[D] = H[D];
        w.class = Ne, w.style = Ve, w.attrs = re, w.on = Q(w.on, dt(te)), i && (f.children = (Array.isArray(f.children) ? f.children : [f.children]).filter((D) => D != null).concat(i));
      }
      return f;
    };
    return () => {
      const a = e.disabled || !l.value && !e.autoUpdateOnClosed;
      return _(et, {
        data: {
          ref: h,
          reference: O.value,
          floating: P.value,
          disabled: a,
          placement: e.placement,
          strategy: e.strategy,
          middleware: B.value,
          autoUpdate: e.autoUpdate,
          onUpdate: (i) => t("floating-data-update", i)
        },
        scopedSlots: {
          default: (i) => Ue(i, We(i, Ie(i)))
        }
      });
    };
  }
});
function Y(e) {
  return Array.isArray(e) ? !e.length : e == null;
}
function Ee(e, t) {
  return t.reduce((r, n) => {
    const o = J(n), l = U(n) ? n : `on${o.charAt(0).toUpperCase()}${o.slice(1)}`;
    return r[l] = (...d) => e(o, ...d), r;
  }, {});
}
var Nt = Object.defineProperty, Vt = Object.defineProperties, zt = Object.getOwnPropertyDescriptors, ue = Object.getOwnPropertySymbols, kt = Object.prototype.hasOwnProperty, Bt = Object.prototype.propertyIsEnumerable, fe = (e, t, r) => t in e ? Nt(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, Se = (e, t) => {
  for (var r in t || (t = {}))
    kt.call(t, r) && fe(e, r, t[r]);
  if (ue)
    for (var r of ue(t))
      Bt.call(t, r) && fe(e, r, t[r]);
  return e;
}, Mt = (e, t) => Vt(e, zt(t));
const De = Se({}, W(T, [
  "placement",
  "strategy",
  "middleware",
  "autoUpdate",
  "open",
  "defaultOpen",
  "disabled",
  "virtualElement",
  "appendTo",
  "interactions",
  "delay",
  "clickDelay",
  "hoverDelay",
  "focusDelay",
  "keepOpenWhenPopupHover",
  "closeWhenClickOutside",
  "autoUpdateOnClosed",
  "offset",
  "shift",
  "flip",
  "autoPlacement",
  "gpuAcceleration",
  "destoryedOnClosed",
  "referenceProps",
  "floatingWrapper",
  "zIndex",
  "onUpdate:open",
  "onOpen",
  "onClose",
  "onFloatingDataUpdate"
])), Re = "visoning-popover", k = Mt(Se({}, De), {
  content: [String, Object],
  title: [String, Object],
  theme: {
    type: String,
    default: "light"
  },
  size: {
    type: String,
    default: "meduim"
  },
  transitionProps: {
    type: [String, Object],
    default: Re
  },
  showArrow: {
    type: Boolean,
    default: !0
  },
  arrow: [Object, Function],
  arrowProps: Object,
  popoverProps: T.popupProps,
  contentProps: T.popupProps,
  popoverWrapper: T.popupWrapper
});
var Ht = Object.defineProperty, Kt = Object.defineProperties, Lt = Object.getOwnPropertyDescriptors, de = Object.getOwnPropertySymbols, qt = Object.prototype.hasOwnProperty, Yt = Object.prototype.propertyIsEnumerable, ve = (e, t, r) => t in e ? Ht(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, A = (e, t) => {
  for (var r in t || (t = {}))
    qt.call(t, r) && ve(e, r, t[r]);
  if (de)
    for (var r of de(t))
      Yt.call(t, r) && ve(e, r, t[r]);
  return e;
}, Gt = (e, t) => Kt(e, Lt(t));
const V = "visoning-popover", Jt = G({
  name: "VisoningPopover",
  props: k,
  setup(e, { emit: t, slots: r }) {
    const n = C(), o = C(), l = ({ placement: s, middlewareData: u }) => {
      var O, P, v, b;
      const x = (P = (O = u.arrow) == null ? void 0 : O.y) != null ? P : 0, h = (b = (v = u.arrow) == null ? void 0 : v.x) != null ? b : 0, S = {
        "--vp-arrow-top": `${x}px`,
        "--vp-arrow-left": `${h}px`
      };
      return s.includes("top") || s.includes("bottom") ? S.left = `${h}px` : S.top = `${x}px`, S;
    }, d = (s) => {
      const u = e.arrow || r.arrow;
      return u ? typeof u == "function" ? u(s) : u : _("div", {
        data: {
          ref: o,
          class: `${V}-arrow`,
          style: l(s)
        }
      });
    }, p = $(() => {
      const s = e.middleware || [];
      return e.showArrow && o.value && s.push(Qe({
        element: o.value
      })), s;
    }), c = (s) => {
      const { transitionProps: u, popoverWrapper: O } = e;
      if (u) {
        const P = typeof u == "string" ? { name: u } : A({ name: Re }, u);
        if (g) {
          const v = s;
          s = _(j.Transition, {
            data: P,
            scopedSlots: {
              default: () => v
            }
          });
        } else
          s = _("transition", {
            data: P
          }, [s]);
      }
      return typeof O == "function" ? O(s) : s;
    }, R = (s) => {
      var u, O, P, v, b;
      const { showArrow: x } = e, h = (O = e.title) != null ? O : (u = r.title) == null ? void 0 : u.call(r), S = (v = e.content) != null ? v : (P = r.content) == null ? void 0 : P.call(r), F = !Y(h), B = !Y(S);
      return _("div", {
        data: A({}, E(e.popoverProps, {
          class: [
            V,
            `size-${e.size}`,
            {
              "theme-dark": e.theme === "dark"
            }
          ],
          "data-placement": s.placement
        }))
      }, [
        _("div", {
          data: E(e.contentProps, {
            class: `${V}-content`
          })
        }, [
          F ? I("div", { class: `${V}-title` }, [h]) : null,
          B ? S : (b = r.default) == null ? void 0 : b.call(r)
        ]),
        x && d(s)
      ]);
    };
    return () => {
      const s = A(A({}, W(e, Object.keys(De))), Ee(t, ["onUpdate:open", "open", "close", "onFloatingDataUpdate"]));
      return _(Ut, {
        data: Gt(A({}, s), {
          ref: n,
          middleware: p.value,
          popupWrapper: c
        }),
        scopedSlots: {
          reference: r.reference,
          default: R
        }
      });
    };
  }
});
var Qt = Object.defineProperty, Xt = Object.defineProperties, Zt = Object.getOwnPropertyDescriptors, ye = Object.getOwnPropertySymbols, er = Object.prototype.hasOwnProperty, tr = Object.prototype.propertyIsEnumerable, me = (e, t, r) => t in e ? Qt(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, Fe = (e, t) => {
  for (var r in t || (t = {}))
    er.call(t, r) && me(e, r, t[r]);
  if (ye)
    for (var r of ye(t))
      tr.call(t, r) && me(e, r, t[r]);
  return e;
}, rr = (e, t) => Xt(e, Zt(t));
const Ae = Fe({}, W(k, [
  "placement",
  "strategy",
  "middleware",
  "autoUpdate",
  "open",
  "defaultOpen",
  "disabled",
  "virtualElement",
  "appendTo",
  "delay",
  "clickDelay",
  "hoverDelay",
  "focusDelay",
  "keepOpenWhenPopupHover",
  "closeWhenClickOutside",
  "autoUpdateOnClosed",
  "offset",
  "shift",
  "flip",
  "autoPlacement",
  "gpuAcceleration",
  "destoryedOnClosed",
  "size",
  "transitionProps",
  "showArrow",
  "arrow",
  "arrowProps",
  "referenceProps",
  "contentProps",
  "floatingWrapper",
  "zIndex",
  "onUpdate:open",
  "onOpen",
  "onClose",
  "onFloatingDataUpdate"
])), nr = rr(Fe({}, Ae), {
  content: [String, Object],
  textAlign: {
    type: String,
    default: "start"
  },
  tooltipProps: k.popoverProps,
  tooltipWrapper: k.popoverWrapper
});
var or = Object.defineProperty, ar = Object.defineProperties, lr = Object.getOwnPropertyDescriptors, _e = Object.getOwnPropertySymbols, sr = Object.prototype.hasOwnProperty, ir = Object.prototype.propertyIsEnumerable, Pe = (e, t, r) => t in e ? or(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, K = (e, t) => {
  for (var r in t || (t = {}))
    sr.call(t, r) && Pe(e, r, t[r]);
  if (_e)
    for (var r of _e(t))
      ir.call(t, r) && Pe(e, r, t[r]);
  return e;
}, cr = (e, t) => ar(e, lr(t));
const ge = "visoning-tooltip", _r = G({
  name: "Tooltip",
  props: nr,
  setup(e, { emit: t, slots: r }) {
    const n = () => {
      var o, l, d;
      const p = (l = e.content) != null ? l : (o = r.content) == null ? void 0 : o.call(r), c = !Y(p);
      return _("div", {
        data: {
          style: {
            textAlign: e.textAlign
          }
        }
      }, [
        I("span", {
          class: `${ge}-content`
        }, [c ? p : (d = r.default) == null ? void 0 : d.call(r)])
      ]);
    };
    return () => {
      const o = K(K({}, W(e, Object.keys(Ae))), Ee(t, ["onUpdate:open", "open", "close", "onFloatingDataUpdate"]));
      return _(Jt, {
        data: cr(K({}, o), {
          interactions: ["hover"],
          popoverProps: E(e.tooltipProps, {
            class: ge
          }),
          popoverWrapper: e.tooltipWrapper
        }),
        scopedSlots: {
          reference: r.reference,
          arrow: r.arrow,
          content: n
        }
      });
    };
  }
});
export {
  Jt as Popover,
  De as PopoverExtendsPopupProps,
  k as PopoverProps,
  Ut as Popup,
  T as PopupProps,
  _r as Tooltip,
  Ae as TooltipExtendsPopoverProps,
  nr as TooltipProps,
  Dt as createReferenceForwardContext,
  St as providePopupContextValue,
  mr as useReferenceForwardContext,
  $e as useSafeReferenceForwardContent
};
